#include "DCmotor.h"

bool DCmotor::checkPWM(uint8_t pin) {
    if(pin == 3 || pin == 5 || pin == 6 || pin == 9 || pin == 10 || pin == 11) return true;
    else return false;
}

DCmotor::DCmotor(uint8_t _A, uint8_t _B) {
    A = _A;
    B = _B;
    pinMode(A, OUTPUT);
    pinMode(B, OUTPUT);
    digitalWrite(A, LOW);
    digitalWrite(B, LOW);
}

void DCmotor::turnDCmotor(int speed) {
    if(speed == 0) {
        digitalWrite(A, LOW);
        digitalWrite(B, LOW);
        return;
    }
    bool MSB, pin;

    if(0 < speed) MSB = 0;
    else MSB = 1;
    if(checkPWM(A) && checkPWM(B)) pin = 1;
    else pin = 0;

    if(pin) {
        analogWrite((MSB == true)?A:B, abs(speed));
        analogWrite((MSB == true)?B:A, 0);
    }
    else {
        digitalWrite((MSB == true)?A:B, HIGH);
        digitalWrite((MSB == true)?B:A, LOW);
    }
}